// 005 u_31_ib_display_data_reader
// 04 oct 2006

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_31_ib_display_data_reader;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data, System.Data.SqlClient, 
  Borland.Data.Provider;

type
  TWinForm = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    clear_: System.Windows.Forms.Button;
    exit_: System.Windows.Forms.Button;
    TextBox1: System.Windows.Forms.TextBox;
    display_invoice_: System.Windows.Forms.Button;
    BdpConnection1: Borland.Data.Provider.BdpConnection;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure exit__Click(sender: System.Object; e: System.EventArgs);
    procedure clear__Click(sender: System.Object; e: System.EventArgs);
    procedure TWinForm_Load(sender: System.Object; e: System.EventArgs);
    procedure display_invoice__Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    { Private Declarations }
  public
    constructor Create;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(TWinForm))]

implementation
  uses u_c_dot_net_display, u_c_dot_net_log ;

{$AUTOBOX ON}

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWinForm.InitializeComponent;
begin
  Self.clear_ := System.Windows.Forms.Button.Create;
  Self.exit_ := System.Windows.Forms.Button.Create;
  Self.TextBox1 := System.Windows.Forms.TextBox.Create;
  Self.display_invoice_ := System.Windows.Forms.Button.Create;
  Self.BdpConnection1 := Borland.Data.Provider.BdpConnection.Create;
  Self.SuspendLayout;
  // 
  // clear_
  // 
  Self.clear_.Location := System.Drawing.Point.Create(88, 8);
  Self.clear_.Name := 'clear_';
  Self.clear_.Size := System.Drawing.Size.Create(48, 24);
  Self.clear_.TabIndex := 5;
  Self.clear_.Text := 'clear_';
  Include(Self.clear_.Click, Self.clear__Click);
  // 
  // exit_
  // 
  Self.exit_.Location := System.Drawing.Point.Create(8, 8);
  Self.exit_.Name := 'exit_';
  Self.exit_.Size := System.Drawing.Size.Create(40, 24);
  Self.exit_.TabIndex := 4;
  Self.exit_.Text := 'exit_';
  Include(Self.exit_.Click, Self.exit__Click);
  // 
  // TextBox1
  // 
  Self.TextBox1.Location := System.Drawing.Point.Create(144, 0);
  Self.TextBox1.Multiline := True;
  Self.TextBox1.Name := 'TextBox1';
  Self.TextBox1.ScrollBars := System.Windows.Forms.ScrollBars.Vertical;
  Self.TextBox1.Size := System.Drawing.Size.Create(328, 120);
  Self.TextBox1.TabIndex := 3;
  Self.TextBox1.Text := 'TextBox1';
  // 
  // display_invoice_
  // 
  Self.display_invoice_.Location := System.Drawing.Point.Create(24, 44);
  Self.display_invoice_.Name := 'display_invoice_';
  Self.display_invoice_.Size := System.Drawing.Size.Create(96, 23);
  Self.display_invoice_.TabIndex := 6;
  Self.display_invoice_.Text := 'display_invoice_';
  Include(Self.display_invoice_.Click, Self.display_invoice__Click);
  // 
  // BdpConnection1
  // 
  Self.BdpConnection1.ConnectionOptions := 'waitonlocks=False;commitretain=F' +
  'alse;sqldialect=3;transaction isolation=ReadCommitted;servercharset=;role' +
  'name=';
  Self.BdpConnection1.ConnectionString := 'assembly=Borland.Data.Interbase, ' +
  'Version=2.5.0.0, Culture=neutral, PublicKeyToken=91d62ebb5b0d1b1b;vendorc' +
  'lient=gds32.dll;pooling=True;grow on demand=True;database=C:\programs\us\' +
  'db\interbase\_data\IB_ORDER_ENTRY.GDB;username=sysdba;max pool size=100;p' +
  'assword=masterkey;provider=Interbase';
  // 
  // TWinForm
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(472, 133);
  Self.Controls.Add(Self.display_invoice_);
  Self.Controls.Add(Self.clear_);
  Self.Controls.Add(Self.exit_);
  Self.Controls.Add(Self.TextBox1);
  Self.Name := 'TWinForm';
  Self.Text := 'WinForm';
  Include(Self.Load, Self.TWinForm_Load);
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TWinForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TWinForm.Create;
begin
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent;
  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

    procedure TWinForm.TWinForm_Load(sender: System.Object; e: System.EventArgs);
      begin
        initialize_display(TextBox1);
        initialize_default_log;
        clear_display;
      end; // TWinForm_Load

    procedure TWinForm.clear__Click(sender: System.Object; e: System.EventArgs);
      begin
        clear_display;
      end; // clear__Click

    procedure TWinForm.exit__Click(sender: System.Object; e: System.EventArgs);
      begin
        Close;
      end; // exit__Click

    const k_select_invoice= 'SELECT * FROM invoice';

    procedure TWinForm.display_invoice__Click(sender: System.Object; e: System.EventArgs);
      var l_c_bdp_command: BdpCommand;
          l_c_reader: iDataReader;
          l_row_index: Integer;
          l_column_index: Integer;
          l_display: String;
      begin
        display_line;
        display('> list_data_table '+ k_select_invoice);

        l_c_bdp_command:= BdpConnection1.CreateCommand();
        l_c_bdp_command.CommandText:= k_select_invoice;

        BdpConnection1.Open();
        l_c_reader:= l_c_bdp_command.ExecuteReader();

        l_row_index:= 0;
        while l_c_reader.Read() do
        begin
          l_display:= '';
          for l_column_index:= 0 to l_c_reader.FieldCount- 1 do
            l_display:= l_display+ ' '+ l_c_reader.GetValue(l_column_index).ToString; 
          display(l_row_index.ToString+ ':'+ l_display);
          Inc(l_row_index);
        end; // while
        BdpConnection1.Close();
        display('< list_data_table');
      end; // display_invoice_click
end.
